<center>
<font color="red" size=5><b>
&nbsp;<br>

This is only a rough draft of the future Help file. <br>
It will be continuously
improved. Just check the <a href="#examples">examples</a>.

</b></font>
</center>

<h1><a name="contents">Contents</a></h1>
&nbsp;&nbsp;&nbsp;<a href="#notes">General notes</a><br>
&nbsp;&nbsp;&nbsp;<a href="#firststart">First start</a><br>
&nbsp;&nbsp;&nbsp;<a href="#fonts">Fonts</a><br>
&nbsp;&nbsp;&nbsp;<a href="#cmdline">Commandline</a><br>
&nbsp;&nbsp;&nbsp;<a href="#description">Parts of the program</a><br>
&nbsp;&nbsp;&nbsp;<a href="#keys">Keyboard shortcuts</a><br>
&nbsp;&nbsp;&nbsp;<a href="#searching">Using the dictionary</a><br>

<h1><a name="notes">General notes</a></h1>

<p></p>

<h2>Goals</h2>
<ul>
  <li>effective searching</li>
  <li>using with the one hand (with a book in the other))</li>
  <li>no superfluous features</li>
</ul>

<h1><a name="firststart">First start</a></h1>
<h2>a) Downloading the database</h2>
<p>If the <i>main.db</i> is not found the <i>Manage Database</i> dialog will appear. <i>Download</i> will download the database file. <a href="#managedb">More</a>.</p>
<p>An alternative is to build a database from the source data. Details are in the README file (supplied with source code) 
</p>


<h2>b) Fonts</h2>
See next section.

<h1><a name="fonts">Fonts</a></h1>
<p>This program requires at least one font that can display ASCII characters (a-z, 0-9, +, -, :, ...) and kanji from the JIS X 208 standard (ideally JIS X 212 and JIS X 213 standards too).
<a href="https://en.wikipedia.org/wiki/List_of_CJK_fonts">The list of the CJK fonts.</a>
</p>
<p><b>Warning: You should restart the program after changing the fonts</b> (to ensure that the change is reflected everywhere)</p>
<p>In Windows 7 and later it is not necessary to set the fonts manually (the system choose it itself), but <b>the kanji in this help will be not visible</b>.</p>
<p>
You can also set fonts from the commandline (see below) or in the <i>Settings</i> (<b><i>Menu -&gt; Settings</i></b>).
</p>

<h2>Recommended fonts:</h2>
<table border="1">
<tr>
<td><i>MS PMincho</i><br><i>MS Mincho</i></td>
<td>Should be present in Windows XP and later. Version from Windows XP does not support JIS X 213. In this case it is better to use some other font; e.g. <i>Hanazono</i>.</td>
</tr>
<tr>
<td><i><font face="symbol">花園</font> (Hanazono)</i></td>
<td>Free font available at <a href="http://fonts.jp/hanazono">http://fonts.jp/hanazono/</a>. The variant <i><font face="symbol">花園明朝A</font> (HanaMinA)</i> is needed. </td>
</tr>
</table>

<h3>Installation of the fonts</h3>
<p>Download and unpack the archive with the selected font and locate the <i>*.TTF</i> files.</p><br>
<ul>
<li><b>Linux: </b>create a directory <i>.fonts</i> in your home directory and move the <i>*.TTF</i> into it.</li>
<li><b>Windows: </b><i>Start -&gt; Control panel -&gt; Fonts</i> and move the <i>*.TTF</i> files into the window.</li>
</ul>

<h1><a name="cmdline">Commandline</a></h1>
<p>All options that may be set in the <b>Settings</b> dialog may be set as a parameter when you start the program. In this case, the commandline parameter has precedence over the one in the Settings. The list of all available options  and default values can be obtained with the command <i>aoi -config help</i></p>
<p>Options are entered in the following format: <i>aoi -config option1=value1:option2=value2:...:optionN=valueN</i>
<br>
e.g.: <i>aoi -config "font/base_size"=18:"font/kanji"="HanaMinA"</i>
</p>
<h2>Other options</h2>
<table border="1">
<tr>
  <td><i>-geomentry WxH+X+Y</i></td>
  <td>Sets the position (X,Y) and size (W,H) of the program [in pixels].
    <ul>
      <li>W - window width</li>
      <li>H - window height</li>
      <li>X - x-coordinate (distance from the left)</li>
      <li>Y - y-coordinate (distance from the right)</li>
    </ul>
    E.g. <i>-geometry 1366x768+0+0</i> (fullscreen on the typical HD display)
  </td>
</tr>
<tr>
  <td><i>-scheme none|GTK+|plastic</i></td>
  <td>Changes the look of the user interface. See screenshots on the <a href="http://aoi.souko.cz">home page</a>.
  </td>
</tr>
<tr>
  <td><i>-loaddb SOUBOR<br>-parse jmdict|kanjidic</i></td>
  <td>For manual creation of the database. See README.</td>
</tr> 
</table>

<h2>Some useful options to use with "-config"</h2>
<table border="1">
<tr><td>font/base_size</td><td>px</td><td>The base size of the fonts in pixels. All the font sizes are based on this value.</td></tr>
<tr><td>font/kanji</td><td>font name</td><td>The font used to diplay kanji.</td></tr>
</table>

<h1><a name="description">Parts of the program</a></h1>
<ul>
  <li>All dialog windows (including windows with kanji) can be closed by pressing <i>ESC</i></li>
</ul>

<h2>Always visible buttons</h2>
<h3>Menu</h3>
<p>Button on the upper left labeled <b>M</b> and arrow.</p>
<table border="1">
<tr><td>
  <a name="managedb"></a>
  <b><i>Menu -&gt; Manage database</i></b></td><td>
  Displays a dialog box with informations about the database that allows download and manage it.<br>
  <b>Download size is about 40 MB and the finished database about 140 MB. Processing the database needs 150-300 MB for temporary files.</b>
</td></tr>
<tr><td>
  <b><i>Menu -&gt; Settings</i></b></td><td>
  Displays a dialog with the programs configuration. 
  <br><u>Odd lines:</u> variable (doubleclick/Enter/Space to show description)
  <br><u>Even lines:</u> its value (doubleclick/Enter/Space to change of the value)
</td></tr>
<tr><td>
  <b><i>Menu -&gt; Tools -&gt; Test romanization</i></b></td><td>
  Shows a dialog in which you can test how the program converts <i>romaji</i> to <i>hiragana/katakana</i>
</td></tr>
<tr><td>
  <b><i>Menu -&gt; Tools -&gt; Test fonts</i></b></td><td>
  Shows a dialog in which you can check the founds (found in your system).
</td></tr>
<tr><td>
  <b><i>Menu -&gt; Help &amp; About</i></b></td><td>
  Shows this help.
</td></tr>
</table>

<h3>Toggle button dictionary/kanji</h3>
<p>Button on the upper left corner; displays <i>D</i> when the dictionary interface is shown, <i>K</i> when the kanji interface.</p>

<h2>Dictionary interface</h2>
<h3>Input field</h3>
<ul>
  <li>You can type romaji (it is converted to hiragana/katakana), hiragana, katakana, kanji and their combinations.</li>
  <li>For the examples of search strings see below.</li>
</ul>
<h3>Filters</h3>
<ul>
  <li>Checkboxes on the right.</li>
  <li>Dictionary will show only records corresponding to the selected options (none selected = all selected).</li>
  <li>You can select <i>nouns</i> (noun), <i>adjectives</i> (adj), <i>verbs</i> (verb) and <i>expressions</i> (exp). </li>
</ul>

<h3>Serch results</h3>
<ul>
  <li>Frequent readings and kanji are highlighted (with color).</li>
  <li>The column width may be changed by dragging the header.</li>
  <li>Rightclick on the row displays a menu. In this menu you can copy/show kanji found in the word, display example sentences and edit the word.</li>
</ul>


<h2>Kanji search</h2>

<h3>SKIP, strokes (#), JLPT and grade (Grd.) input fields</h3>
<ul>
  <li>Enter works in the same manner as button <i>Search</i> in these fields</li>
  <li>Description of the possible search options are in the section <a href="#searching">using the dictionary</a></li>
</ul>

<h3>Sort kanji</h3>
<p>Sets the sort order. Options: by <i>the frequence of occurence in japanese texts</i> (FREQ), by <i>the stroke count</i> (STROKES), <i>the ascending sort</i> (ASC) and <i>the descending sort</i> (DESC). </p>

<h3>JIS 208 only</h3>
<p>If this option is enabled it will search only for the kanji from the <i>JIS X 208</i> standard (about 6500 most frequent kanji; sufficient for regular texts).</p>

<h3>Search button</h3>
<p>Searches kanji meeting all the set options/filters (same as Enter in one of the input fields).</p>

<h3>Clear button</h3>
<p>Restores a default state of all the fields.</p>

<h3>Components</h3>
<ul>
  <li><b>Sort by strokes</b> toggles between <i>sort by the frequence of occurence</i> of the component in the search results and <i>sort by the stroke count</i> of the component (components are still sorted by the frequence of occurence).</li>
  <li>Leftclick shows only the kanji that contains the selected component.</li>
  <li>Rightclick shows only the kanji that does not contain the selected component.</li>
  <li>Selection of the component may be cancelled by the same button which selected it (leftclick for included components and right click for excluded).</li>
</ul>

<h3>Search results</h3>
<ul>
  <li>Kanji, which are most commonly found in Japanese texts are highlighted in color.</li>
  <li>Leftclick shows a dialog with the kanji details.</li>
  <li>Rightclick shows a context menu.</li>
</ul>

<h1><a name="keys">Keyboard shortcuts</a></h1>
<table border="1">
<tr>
  <td><b>CTRL+M</b></td>
  <td>Shows a main menu.</td>
</tr><tr>
  <td><b>CTRL+L</b></td>
  <td>Moves the focus to the search input (SKIP input in the kanji dictionary).</td>
</tr><tr>
  <td><b>CTRL+S</b></td>
  <td>Performs the search; same as <i>ENTER</i> in the search fielsd or button <i>Search</i>.</td>
</tr><tr>
  <td><b>CTRL+Q</b></td>
  <td>Toggles display dictionary/kanji.</td>
</tr><tr>
  <td><b>ESC</b></td>
  <td>Closes actual dialog/window (not the main window).</td>
</tr>
</table>


<h1><a name="searching">Using the ditionary</a></h1>

<h2>Dictionary</h2>
In the following table the term <i>character</i> represents one hiragana/katakana/kanji letter.

<b>WARNING:</b> The first step the program performs (before queriying the database)
is the conversion of the input string to kanji, hiragana, katakana and special characters.
</p>

<table border="1">
<tr>
  <td><b>:</b></td>
  <td>Indices the search in the direction <i>English -&gt; Japanese</i>. In this case, the following
      options does not work. Case sensitive.</td>
</tr><tr>
  <td><b>*</b></td>
  <td>Replaces 0 or more charactres.</td>
</tr><tr>
  <td><b>?</b></td>
  <td>Replaces exactly one character.</td>
</tr><tr>
  <td><b>[]</b></td>
  <td>Square brackets may contain the list of the words (i.e. their readings) separated by commas. The result of the operation is a list of kanji that appears in all of those words. The searched string must contain exactly one kanji from the list (in this specific position).</td>
</tr><tr>
  <td><b>()</b></td>
  <td>Similar to [] but instead of readings of the words readings of the kanji is used (no distinction is made between <i>onyomi</i> and <i>kunyomi</i>). Replaces one character.<br>
<b>WARNING: </b> Using this at the beggining of the search string (i.e. preceeded by * or ?; e.g.:<i>*(sei), ??(sei), (chi)*, (chi)(ji), ...</i>) can lead to a very broad search, which will take a few minutes on slower CPU. String like <i>[tadashii](to)</i> are not a problem.</td>
</tr><tr>
  <td><b>{}</b></td>
  <td>String in the curly brackets is first converted to hiragana and katakan. The searched reading must contain exactly one character from the list (in this specific position).</td>
  </tr>
</table>

<p><b>[]</b> and <b>()</b> may contain also a number 1, 2, 3 or 4. This specifies the SKIP category of the described kanji.
<b>WARNING:</b> If there are 2 numbers in the string the search results will be almost always zero (kanji has usually only one SKIP category). Searches the SKIP ans misclassed SKIP codes.</p>


<h3><a name="examples">Examples of search strings</a></h3>
<p>
Romaji, hiragana and katakana are fully interchangeable (e.g. all these strings are equivalent: <font face="symbol">baka, ばか, バカ, baか, ばka, baカ, バka, ばカ, バか</font>). The only exception is the search in the direction <i>English -&gt; Japanese</i>.
</p>

<table border="1">
<tr>
  <th>String</th>    
  <th>What is searched for</th>    
  <th>Example of results</th>    
</tr>
<tr>
  <td>:easy</td>    
  <td>fulltext search for the string <i>easy</i> (in english meanings)</td>    
  <td><font face="symbol">易しい (easy) <br>重い (uneasy)</font></td>    
</tr>
<tr>
  <td>:to see</td>    
  <td>fulltext search for the string <i>to see</i> (in english meanings)</td>    
  <td><font face="symbol">見る (to see) <br> 見える (to seem) <br> 求める (to seek)</font></td>    
</tr>
<tr>
  <td>ana*</td>    
  <td>readings that starts with <font face="symbol">あな </font>or <font face="symbol">アナ</font></td>    
  <td><font face="symbol">穴 (あな)<br>強ち (あながち) <br> アナウンサー</font></td>    
</tr>
<tr>
  <td>*ana</td>    
  <td>readings that ends with <font face="symbol">あな </font>or <font face="symbol">アナ</font></td>    
  <td><font face="symbol">穴 (あな)<br>毛穴 (けあな) <br>ルイジアナ</font></td>    
</tr>
<tr>
  <td>?ana</td>    
  <td>readings that starts by any character followed by <font face="symbol">あな </font>or <font face="symbol">アナ</font></td>    
  <td><font face="symbol">毛穴 (けあな)<br> ギアナ</font></td>    
</tr>
<tr>
  <td>[otonashii]</td>    
  <td>1-kanji words; tha kanji may appear in any word with the reading <i>otonashii</i> (<font face="symbol">大人しい</font>)</td>    
  <td><font face="symbol">人 and 大</font></td>    
</tr>
<tr>
  <td>[aozora,aomushi]</td>
  <td>1-kanji words; the kanji appears in <b>both</b> <i>aozora</i> (<font face="symbol">青空</font>) and <i>aomushi</i> (<font face="symbol">青虫</font>)</td>
  <td><font face="symbol">青</font></td>
</tr>
<tr>
  <td>*[aozora,aomushi]</td>
  <td>same as *<font face="symbol">青</font></td>
  <td><font face="symbol">緑青<br>青<br>プロシア青</font></td>
</tr>
<tr>
  <td>[1,ichi]</td>
  <td>1-kanji words; the kanji may appears in <i>ichi</i> (<font face="symbol">一, 市, 壱, 位置 or 位地</font>) <b>and</b> its <a href="https://en.wikipedia.org/wiki/SKIP_code">SKIP</a> category is 1</td>
  <td><font face="symbol">地 and 位</font></td>
</tr>
<tr>
  <td>?[nihon]*</td>
  <td>2-letter or longer words;<br> 
    the <u>first</u> letter may be any character<br> 
    the <u>second</u> leter is <font face="symbol">日, 本 or 二 (because both 日本 and 二本 </font>can be read as <i>nihon</i>)</td>
  <td><font face="symbol">一本<br>第二次世界大戦<br>根本的</font></td>
</tr>
<tr>
  <td>?[2,nihon]*</td>
  <td>2-letter or longer words;<br> 
    the <u>first</u> letter may be any character<br> 
    the <u>second</u> letter is <font face="symbol">二 </font>(<font face="symbol">二 </font>has <a href="https://en.wikipedia.org/wiki/SKIP_code">SKIP</a> category 2, <font face="symbol">日 </font>and <font face="symbol">本 </font>category 4)</td>
  <td><font face="symbol">十二<br>第二次世界大戦<br>十二月</font></td>
</tr>
<tr>
  <td>?[sei]?[waei]</td>
  <td>4-letter words;
    <br>the <u>first</u> and <u>third</u> letter may be any character; 
    <br>the <u>second</u> letter is a kanji that appears in <i>sei</i> (<font face="symbol">世,井,制,勢,姓,性,所,政,斉,旌,星,正,為,生,精,聖,背,脊,製,西,静 or 齊</font>)
    <br>the <u>fourth</u> letter is a kanji that appears in <i>waei</i> (<font face="symbol">和英</font>)</td>
  <td><font face="symbol">規制緩和 <br> 資性穏和</font></td>
</tr>
<tr>
  <td>?[ookii][fu]?</td>
  <td>4-letter words;
    <br>the <u>first</u> and <u>fourth</u> letter may be any character; 
    <br>the <u>second</u> letter is a kanji that appears in <i>ookii</i> (<font face="symbol">大きい</font>);
    <br>the <u>third</u> letter is a kanji that appears in <i>fu</i> (<font face="symbol">不,二,傅,婦,布,府,斑,歩,生,符,腑,訃,譜,負,賦,駁,駮,麩 or 麸</font>)
</td>
  <td><font face="symbol">尊大不遜</font></td>
</tr>
<tr>
  <td>(too)</td>
  <td>1-kanji words; the kanji's <i>onyomi</i> or <i>kunyomi</i> contains <font face="symbol">とお </font>or <font face="symbol">トオ</font></td>
  <td><font face="symbol">十<br>通<br>回</font></td>
</tr>
<tr>
  <td>(4,ji)</td>
  <td>1-kanji words; the kanji's <i>onyomi</i> or <i>kunyomi</i> contains <font face="symbol">じ </font>or <font face="symbol">ジ </font><b>and</b> its <a href="https://en.wikipedia.org/wiki/SKIP_code">SKIP</a> category is 4</td>
  <td><font face="symbol">事 (じ)<br>人 (じん)<br>未 (ひつじ)</font></td>
</tr>
<tr>
  <td>(4,too)[bunpou]</td>
  <td>2-kanji words;<br>
    the <u>first</u> kanji's <i>onyomi</i> or <i>kunyomi</i> contains <font face="symbol">とお </font>or <font face="symbol">トオ </font><b> and </b>its <a href="https://en.wikipedia.org/wiki/SKIP_code">SKIP</a> category is 4<br>
    the <u>second</u> kanji which appears in <i>bunpou</i> (<font face="symbol">文法, 文保 or 分封</font>)</td>
  <td><font face="symbol">十分</font></td>
</tr>
<tr>
  <td>{babo}{kuka}</td>
  <td>2-letter readings; the first letter is <font face="symbol">ば, ぼ, バ or ボ</font> and the second letter is <font face="symbol">く, か, ク or カ</font> </td>
  <td><font face="symbol">僕 (ぼく) <br> 馬鹿 (ばか)</font></td>
</tr>
</table>


<h2>Kanji</h2>
<ul>
<li>You can search by the SKIP code, stroke count, JLPT, grade and components.</li>
<li>When you are entering the stroke count, JLPT or grade you can use a fuzzy search.
  <table border="1">
    <tr><td>5+</td><td>5 or more strokes</td></tr>
    <tr><td>5-</td><td>5 or less strokes</td></tr>
    <tr><td>5-11</td><td>between 5 and 11 strokes</td></tr>
  </table>
</li>
<li>When you are entering the SKIP code, you can use a fuzzy search too (but not for the first parameter). The second and third number are optional. The search takes into account the most common errors in identifying kanji.
  <table border="1">
    <tr><th>input</th><th>searched SKIP</th></tr>
    <tr><td>1 3 5</td><td>1-3-5</td></tr>
    <tr><td>1</td><td></td>1-X-Y</tr>
    <tr><td>1 4-7</td><td></td>1-4-X, 1-5-X, 1-6-X, 1-7-X</tr>
    <tr><td>1 6 5-</td><td>1-6-5, 1-6-4, 1-6-3, 1-6-2, 1-6-1</td></tr>
    <tr><td>1 2-5 5-9</td><td></td></tr>
  </table>
  &nbsp;<br>
</li>
<li>If the <i>JIS 208 only</i> option is active, only the kanji from the JIS X 208 standard are searched (about 6500 most common kanji; sufficient for regular texts). In the other case all 13108 kanji from standards JIS X 208, JIS X 212 and JIS X 213 are used.</li>
<li><b>All active choices are applied in the search.</b></li>
</ul>



